
#include "simulator.h"


void set_initial_facts()
{

  token_list temp_ft;
  init_g_table();
  for( temp_ft = actual_initial_facts; temp_ft; temp_ft = temp_ft->next )
  {
      temp_ft->go_pointer->gpg.is_true=TRUE;
  }
}


void set_goals()
{
  token_list temp_ft;
  g_node_list temp_go;
  init_g_table();
  for( temp_ft = actual_goal_facts; temp_ft; temp_ft = temp_ft->next )
  {
     temp_go = quick_lookup_go(temp_ft);
     if (temp_go!=NULL)
        temp_go->gpg.is_true=TRUE;
  }
}


void change_plan(int num_noise_initial_facts, int num_noise_goals, fact_list objects_list, 
                 token_list inertia_list, token_list f_list, token_list g_list, char* fct_file)
{
  int i,j,g;
  char ProblemFileName[MAX_LENGTH];
  char* TempName;

  set_initial_facts();

  i=0;
  for(j=0;i<num_noise_initial_facts && j<1000;j++)
    if ( apply_noisy_operator() )
    {
       i++;
       update_facts();
    }
  set_goals();
  i=0;

  for (j=0;i<num_noise_goals  && j<1000;j++)
     if ( apply_noisy_goal() )
     {
        i++;
        update_goals();
     }

  TempName=new_token(strlen(fct_file)+1);
  strncpy(TempName,fct_file,strlen(fct_file)-5);
  sprintf(ProblemFileName,"%s-I%d-F%d.pddl",TempName,num_noise_initial_facts,num_noise_goals);
  generate_pddl_input (NULL,ProblemFileName, objects_list, inertia_list, actual_initial_facts, actual_goal_facts);

}


