#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "simulator.h"


#define MAX_NODES 1000
#define NODE_STR 10
#define CONNECTION "CONN"
#define PESO 20
#define Inf 10000


struct nodes
{
   int to;
   float w;
   struct nodes* next;
};

struct graph
{
   int indx;
   char *from;
   struct nodes* next;
};

struct	graph *ADJ[MAX_NODES];
float minpl[MAX_NODES];
float newpl[MAX_NODES];
BOOLEAN expand[MAX_NODES];
int nearest;
float nearest_pl;
float min;


int trova_max(int l1, int l2)
{
   if (l1>l2) 
     return(l1);
   else 
     return(l2);
}


void add_connection_vect(char *fr)
{
   int i=0,l1,l2,max;
   BOOLEAN trov=FALSE;
 
   if (ADJ[0]==NULL)
   {
      ADJ[0]=(struct graph*)malloc(sizeof(struct graph));
      ADJ[0]->next=NULL;
      ADJ[0]->indx=0;
      ADJ[0]->from=new_token(strlen(fr)+1);
      ADJ[0]->from=fr;
   } 

   for (i=1;i<MAX_NODES && ADJ[i]!=NULL && trov==FALSE;i++) 
   {
      l1=strlen(ADJ[i]->from);
      l2=strlen(fr);
      max = trova_max(l1,l2);
      if (strncmp(ADJ[i]->from,fr,max)==0)
         trov=TRUE;
   }   
    
   if (trov==FALSE && ADJ[i]==NULL && i<MAX_NODES)
   {
      ADJ[i]=(struct graph*)malloc(sizeof(struct graph));
      ADJ[i]->next=NULL;
      ADJ[i]->indx=i;
      ADJ[i]->from=new_token(strlen(fr)+1);
      ADJ[i]->from=fr;
   }
}


void add_connection(char *fr,char *t)
{
   int i=0;
   int k,l1,l2,max;
   BOOLEAN trov=FALSE;
   struct graph *testa;
 
   for (k=0;k<MAX_NODES && ADJ[k]!=NULL && trov==FALSE;k++) 
   {
      l1=strlen(ADJ[k]->from);
      l2=strlen(t);
      max = trova_max(l1,l2);
      if (strncmp(ADJ[k]->from,t,max)==0)
         trov=TRUE;
   }

   if (trov==TRUE && k!=0) 
      k--;
 
   for (i=0;i<MAX_NODES && ADJ[i]!=NULL;i++) 
   {
      l1=strlen(ADJ[i]->from);
      l2=strlen(fr);
      max = trova_max(l1,l2);

      if (strcmp(ADJ[i]->from,fr)==0)
      {
         testa=(struct graph*)malloc(sizeof(struct graph));
         testa->next=ADJ[i]->next;
     	 ADJ[i]->next=testa;
    	 ADJ[i]->next->w=PESO;
    	 ADJ[i]->next->to=ADJ[k]->indx;
    	 break;
     }
  }
}

   
void remove_connection(char *fr,char *t)
{
   int i=0;
   int k,l1,l2,max;
   BOOLEAN trov=FALSE;
   BOOLEAN deleted=FALSE;
   struct nodes *pntr;
   struct nodes *aux_pntr;
 
   for (k=0;k<MAX_NODES && ADJ[k]!=NULL && trov==FALSE;k++) 
   {
      l1=strlen(ADJ[k]->from);
      l2=strlen(t);
      max = trova_max(l1,l2);
      if (strncmp(ADJ[k]->from,t,max)==0)
         trov=TRUE;
   }

   if (trov==TRUE) 
      k--;
 
   for (i=0;i<MAX_NODES && ADJ[i]!=NULL && deleted==FALSE;i++) 
   {
    
      if (strcmp(ADJ[i]->from,fr)==0) 
      {
         if (ADJ[i]->next->to==k)
         {
            pntr=ADJ[i]->next->next;
            free(ADJ[i]->next);
            ADJ[i]->next=pntr;
            deleted=TRUE;
         }
         else
         {
            pntr=ADJ[i]->next;
            aux_pntr=ADJ[i]->next->next;
            while (pntr->next)
            {
               if (aux_pntr->to==k && aux_pntr->next!=NULL)
               {
                  pntr->next=aux_pntr->next;
                  free(aux_pntr);
                  deleted=TRUE;
               }
               else if (aux_pntr->next==NULL) 
               {
                  pntr->next=NULL;
                  free(aux_pntr);
                  deleted=TRUE;
               } 
               
	       if (deleted==TRUE) 
	          break;
		  
               pntr=pntr->next;
               aux_pntr=aux_pntr->next;
           }
        }
     } 
  }
 
  if (deleted==FALSE) 
  {
     printf("\n CONNECTION REQUESTED IS NOT PRESENT\n");   
  }
}


void free_graph(void)
{
   int i;
   struct nodes *tempnodes;
   struct nodes *tempnodesaux;
 
   for (i=0;i<MAX_NODES;i++)
   {
     if (ADJ[i]!=NULL)
     {
        if (ADJ[i]->next==NULL)
	   free(ADJ[i]);
        else
        {
           tempnodes=ADJ[i]->next;
           
	   while (tempnodes!=NULL) 
           {
              tempnodes=ADJ[i]->next;
              tempnodesaux=tempnodes->next;
    	      ADJ[i]->next=tempnodesaux;
    	      tempnodesaux=tempnodes;
    	      free(tempnodesaux);
    	      tempnodes=ADJ[i]->next;
           } 
        }
     }
   } 
}


void create_graph(void)
{
   int i;
   char *fromaux;
   char *toaux;
 
   token_list tmppntr,temp;
   
   free_graph();
   
   for (i=0;i<MAX_NODES;i++) 
      ADJ[i]=NULL;

   for(temp=actual_initial_facts;temp;temp=temp->next)
   {
//      if (strstr(temp->item,CONNECTION))
      if (strncmp(temp->item,CONNECTION,3)==0)
      {
	 tmppntr=token_list_from_string(temp->item);
	 fromaux=new_token(strlen(tmppntr->next->item)+1);
	 fromaux=tmppntr->next->item;
	 toaux=new_token(strlen(tmppntr->next->next->item)+1);
	 toaux=tmppntr->next->next->item;
	 add_connection_vect(fromaux);
      }
   }

   for(temp=actual_initial_facts;temp;temp=temp->next)
   {
//      if (strstr(temp->item,CONNECTION))
      if (strncmp(temp->item,CONNECTION,3)==0)
      {
	 tmppntr=token_list_from_string(temp->item);
	 fromaux=new_token(strlen(tmppntr->next->item)+1);
	 fromaux=tmppntr->next->item;
	 toaux=new_token(strlen(tmppntr->next->next->item)+1);
	 toaux=tmppntr->next->next->item;
	 add_connection(fromaux,toaux);
      }
   }
}


BOOLEAN dijkstra(char* da,char* a)
{
   struct nodes *p;
   int k,l1,l2,max;
   int i,h;
   BOOLEAN trov=FALSE;
   
   for (k=0;k<MAX_NODES && ADJ[k]!=NULL && trov==FALSE;k++) 
   {
      l1=strlen(ADJ[k]->from);
      l2=strlen(da);
      max = trova_max(l1,l2);    
      if (strncmp(ADJ[k]->from,da,max))
         trov=TRUE;
   } 
   if (trov==TRUE)
      k--;
   remove_connection(da,a); 

   for (i=0;i<MAX_NODES;i++)
   { 
      expand[i]=FALSE;
      minpl[i]=0;
      newpl[i]=Inf;
   }
   nearest_pl=0;
   nearest=k;
   
   while (nearest_pl != Inf)
   {
      expand[nearest]=TRUE;
      for(p=ADJ[nearest]->next;p;p=p->next)
      {
	if (newpl[p->to]>= nearest_pl+p->w)
  	  newpl[p->to]=nearest_pl+p->w;
      }		
      min=Inf;
      
      for (i=0;i<MAX_NODES;i++)
      {
	if (newpl[i]<min && expand[i]==FALSE) 
	{
	   min=newpl[i];
	   nearest=i;
	}
      }
      nearest_pl=min;
   }
   
   for (i=0;i<MAX_NODES;i++) 
      minpl[i]=newpl[i];
   trov=FALSE;

   for (h=0;h<MAX_NODES && ADJ[h]!=NULL && trov==FALSE;h++) 
   {
      l1=strlen(ADJ[h]->from);
      l2=strlen(a);
      max = trova_max(l1,l2);
      if (strncmp(ADJ[h]->from,a,max)==0)
         trov=TRUE;
   }
   if (trov==TRUE) 
      h--;

   add_connection(da,a);

   if (minpl[h]!=Inf) 
      return(TRUE);
   else 
      return(FALSE);
}
