
#ifndef __PDDL_PARSER_H
#define __PDDL_PARSER_H

#include "simulator.h"
#include "ipp4.h"
#include "pddl.h"
#include "pddl-types.h"
#include "instantiateI.h"
#include "instantiateII.h"
#include "instantiateIII.h"
#include "instantiateIV.h"
#include "memory.h"

token_list tl_before;
token_list tl_now;
token_list base;

token_list token_list_from_CodeNode (CodeNode *node, int firstcall);
operator_list operator_list_from_CodeOperator (CodeOperator* base_code_op);
operator_list noisy_operator_from_CodeOperator (CodeOperator* base_code_op);
token_list token_list_from_FactInfo ( FactInfo *f );
FactList* types_list_from_types_table (StringIntegers* gtypes_table);
token_list get_inertials (token_list all_facts, token_list relevant_facts);

void fact_string_underscores (char* out_string, short int predicate, ArgArray arguments );
void inst_operator_string_underscores (char* out_string, CodeOperator* op);

void clean_parsing_memory();


#endif __PDDL_PARSER_H